package killer_sokoban;

import java.util.HashMap;

public abstract class AbstractField {
	
	
	protected HashMap<Direction, AbstractField> neighbours=new HashMap<Direction, AbstractField>();
	
	/**Ez a függvény azt jelzi a mező számára, hogy szeretnének rálépni.
	 * @param toward melyik irányból szeretnének rálépni
	 * @param w	munkás, aki a tolást indította
	 * @param m	mozgatható dolog a pályán, ez szeretne a mezőre lépni
	 * @return ha befogadja a paraméterül kapott Moveable-t, true-val tér vissza, ellenkező esetben false-szal.
	 */
	abstract public boolean accept(Direction toward, Worker w, Moveable m);
	
	/** Megkérdezi a mezőtől, hogy ha egy tolás következne be a paraméterként átadott irányba, akkor ez lehetséges-e.
	 * @param toward ebbe az irányba következne be a tolás
	 * @return	ha lehetséges a tolás, true-val tér vissza, egyébként false-szal.
	 */
	abstract public boolean couldMoveOn(Direction toward);
	
	/** Az adott irányba beállítja, hogy ki a mező szomszédja.
	 * @param d megadott irány
	 * @param n	a szomszéd
	 */
	public void setNeighbour(Direction d, AbstractField n)
	{
		neighbours.put(d,n);
	}
	
	public void printStat()
	{

		System.out.println("neighborUp: " + Main.getFieldName(neighbours.get(Direction.UP)));
		System.out.println("neighborRight: " + Main.getFieldName(neighbours.get(Direction.RIGHT)));
		System.out.println("neighborDown: " + Main.getFieldName(neighbours.get(Direction.DOWN)));
		System.out.println("neighborLeft: " + Main.getFieldName(neighbours.get(Direction.LEFT)));
	}
	
	public void shouldDraw(View view)
	{
		view.drawAbstract();
	}

}
