package killer_sokoban;


public class Crate extends Moveable {

	private boolean couldMove=true;
	private boolean isOnTarget;
	
	
	/**
	 * A láda elveszik, és nem vesz részt a további játékban.
	 */
	public void kill()	{	
		Main.deleteCrate(this);
		super.kill();
	}
	
	/**Ha a láda célmezőre került, akkor kerül meghívásra ez a függvény.
	 * @param w a munkás, aki a tolást indította
	 */
	public void stepOnTarget(Worker w)	{
		w.incrementPoint();
		isOnTarget=true;   
	}
	
	/**Ha a láda a célmezőről lekerült, akkor kerül meghívásra ez a függvény.
	 * @param w a munkás, aki a tolást indította
	 */
	public void stepOffTarget(Worker w)	{
		w.decrementPoint();
		isOnTarget=false;  
	}
	
	/** Ha a láda kapcsolóra került, akkor kerül meghívásra ez a függvény.
	 * @param s kapcsolót tartalmazó mező
	 */
	public void onSwitch(SwitchField s) {
		s.turnOn();
	}
	
	/**
	 * Beállítja, hogy a láda eltolható-e.
	 */
	public void setCouldMove(boolean b) {
		couldMove=b;
	}
	
	public void printStat()
	{
		super.printStat();
		System.out.println("couldMove: " + couldMove);
		System.out.println("isOnTarget: " + isOnTarget);
	}
	
	@Override
	public void shouldDraw(View view)
	{
		super.shouldDraw(view);
		view.drawCrate();
	}
}
