package killer_sokoban;


public enum Direction {
	
	LEFT (0),
	UP (1),
	RIGHT (2),
	DOWN (3);
	
	Direction(int ID)
	{
		this.ID=ID;
	}
	private final int ID;
	
	
	public int getID()
	{		
		return ID;
	}
	
	public static Direction Dir(int num)
	{
		switch (num)
		{
		case 0 : return LEFT;
		case 1 : return UP;
		case 2 : return RIGHT;
		default : return DOWN;
		}
	}
	public static Direction fromString(String dir)
	{
		switch (dir)
		{
		case "left" : return LEFT;
		case "up" : return UP;
		case "right" : return RIGHT;
		default : return DOWN;
		}
	}
	public  Direction opposite()
	{
		switch (this)
		{
		case RIGHT : return LEFT;
		case DOWN: return UP;
		case LEFT : return RIGHT;
		default : return DOWN;
		}
	}
	
	@Override
	public String toString() {
		switch (this)
		{
			case RIGHT : return "right";
			case DOWN : return "down";
			case LEFT : return "left";
			case UP : return "up";
			default : return "direction";
		}
	}
}
