package killer_sokoban;


import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;
 
public class View {
	
	private int line, column;
	private int y, x;
	private GraphicsContext gc;
	
	private int tileSize=20;
	private int cratemargin=3;
	
	public void init(int line, int column)
	{
		this.line=line;
		this.column=column;
	}
	public void setCanvas(Canvas c)
	{
		this.gc=c.getGraphicsContext2D();
	}
	
	public void update()
	{
		gc.clearRect(0, 0, column*tileSize, line*tileSize);
		for (x=0;x<column;x++)
			for (y=0;y<line;y++)
				Main.drawRequiredFor(y,x);
				
	}
		 
	 public void drawAbstract() {
		 gc.setLineWidth(1);
		 gc.setStroke(Color.BLUE);
		 gc.strokeRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 
	 public void drawSimpleField() {		
	 }
	 
	 public void drawTargetField() {
		 gc.setFill(Color.YELLOW);
		 gc.fillRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawHole() {
		 gc.setFill(Color.BLACK);
		 gc.fillRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawSwitchableHole() {
		 gc.setFill(Color.PINK);
		 gc.fillRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawSwitchField() {
		 gc.setFill(Color.PLUM);
		 gc.fillRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawWall() {
		 gc.setFill(Color.GREY);
		 gc.fillRect(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawOil() {
		 gc.setFill(Color.SLATEGREY);
		 gc.fillOval(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 public void drawHoney() {
		 gc.setFill(Color.GOLD);
		 gc.fillOval(x*tileSize, y*tileSize, tileSize, tileSize);
	 }
	 
	 public void drawWorker() {
		 gc.setFill(Color.GREEN);
		 gc.fillPolygon(new double[]{(x+0.1)*tileSize, (x+0.9)*tileSize, (x+0.5)*tileSize},
                 new double[]{(y+0.9)*tileSize, (y+0.9)*tileSize, (y+0.1)*tileSize}, 3);
	}
	 public void drawCrate() {
		 gc.setFill(Color.ORANGE);
		 gc.fillRect(x*tileSize+cratemargin, y*tileSize+cratemargin, tileSize-2*cratemargin, tileSize-2*cratemargin);
	 }
	 
	 
}
